
class CycleFilter:
    def __init__(self,input):
        self.input = input

    def reset(self):
        self.cycle = 0
        self.experiment = 0
        self.lastparentscan = None
        self.input.reset()

    def __iter__(self):
        return self.next()

    def next(self):
        for s in self.input:
            # print s
            psn = s.get('precursorMz.precursorScanNum',None)
            if psn != None:
                if psn != self.lastparentscan:
                    self.cycle += 1
                    self.experiment = 2
                    self.lastparentscan = psn
                else:
                    self.experiment += 1
                s.set('cycle',self.cycle)
                s.set('experiment',self.experiment)
                if s.get('num',None)!=None:
                    s.set('scan',s.get('num',-1))
            elif s.get('msLevel',1) == 1:
                self.cycle += 1
                self.experiment = 1
                self.lastparentscan = s.get('num',-1)
                s.set('cycle',self.cycle)
                s.set('experiment',self.experiment)
                if s.get('num',None)!=None:
                    s.set('scan',s.get('num',-1))
            elif s.get('msLevel',1) == 2 and self.lastparentscan >= 0:
                self.experiment += 1
                s.set('cycle',self.cycle)
                s.set('experiment',self.experiment)
                if s.get('num',None)!=None:
                    s.set('scan',s.get('num',-1))
            yield s
