
from fopen import *
from Spectrum import Spectrum
import re
import urllib

class MRFFileReader:
    def __init__(self,f):
        self.h = fopen(f,'r')

    def __del__(self):
        self.h.close()
        
    def __iter__(self):
        return self.next()


#title=File%3a%20011907OL_2%2ewiff%2c%20Sample%3a%20Ribosomes10min%20%28sample%20number%201%29%2c%20Elution%3a%2098%
 #2e07%20to%2098%2e09%20min%2c%20Period%3a%201%2c%20Cycle%28s%29%3a%204185%20%28Experiment%202%29%2c%204184%20%28Expe
# riment%203%29
# charge=2+
# mass_min=71.077100
# mass_max=877.147700
# int_min=0.0045
# int_max=0.4528
# num_vals=241
# num_used1=-1
# Ions1=86.102100:0.2601,231.131600:0.0812,271.728100:0.0734,405.749300:0.0269,570.479888:0.0531,646.157500:0.4528,69

    def next(self):
        sectionre = re.compile(r'^Content-Type: application/x-Mascot; name="query(\d+)"\s*$')
        precursorre = re.compile(r'^qexp(\d+)=(.*),(\d)\+$')
        precmz = {}
        s = None
        for l in self.h:
            if not s:
                m = sectionre.search(l)
                if m:
                    queryno = int(m.group(1))
                    s = Spectrum()
                    s.set('title','Query %d'%queryno)
                    s.set('precursorMz',precmz[queryno])
                    continue
                m = precursorre.search(l)
                if m:
                    precmz[int(m.group(1))] = float(m.group(2))
                    continue
                continue
            else:
                l = l.strip()
                sl = l.split('=')
                if len(sl) == 2:
                    if sl[0] == 'charge':
                        try:
                            chargestr = sl[1].rstrip('+')
                            s.set('precursorMz.precursorCharge',int(chargestr))
                        except:
                            pass
                    elif sl[0] == 'title':
                        s.set('comment',urllib.unquote(sl[1]))
                    elif sl[0] == 'Ions1':
                        s.set('msLevel',2)
                        xyions = sl[1].split(',')
			xyions.sort(key=lambda p: float(p.split(':')[0]))
                        xdata = [ p.split(':')[0] for p in xyions ]
                        ydata = [ p.split(':')[1] for p in xyions ]
                        for (x,y) in zip(xdata,ydata):
                            s.addPeak(float(x),float(y))
                        yield s        
                        s = None

        self.h.close()

