
import array

class Spectrum:
    def __init__(self):
        self.mz_ = array.array('d')
        self.it_ = array.array('d')
        self.md_ = {}
    def addPeak(self,mz,it):
        self.mz_.append(mz)
        self.it_.append(it)
    def mz(self,mz=None):
        if mz:
            self.mz_ = array.array('d',mz)
        else:
            return list(self.mz_)
    def it(self,it=None):
        if it:
            self.it_ = array.array('d',it)
        else:
            return list(self.it_)
    def peaks(self):
        return len(self.mz_)
    def get(self,key,df=None):
        return self.md_.get(key,df)
    def set(self,key,value):
        self.md_[key] = value
    def metadata(self):
        return self.md_
    def __str__(self):
        s = "BEGIN SPECTRUM\n"
        i = self.md_.items()
        i.sort(key=lambda i: i[0])
        for (k,v) in i:
            s += "%s:\t%s\n"%(k,v)
        for (mz,it) in zip(self.mz_,self.it_):
            s += "%f\t%f\n"%(mz,it)
        s += "END SPECTRUM\n"
        return s
