
from MzXMLFile import MzXMLFileReader,MzXMLFileWriter
from MGFFile import MGFFileReader,MGFFileWriter
from MRFFile import MRFFileReader
from JSONFile import JSONWriter
from MzDataFile import MzDataFileReader
from CycleFilter import CycleFilter
from OrdinalFilter import OrdinalFilter
from Filter import Filter
from MS2Filter import MS2Filter
from HeadFilter import HeadFilter
from ScanIs import ScanIs
from TopNPeaks import TopNPeaks
from AtLeastNPeaks import AtLeastNPeaks
from PrecursorSort import PrecursorSort
from ScanDefault import ScanDefault
from DTADir import DTADirWriter
from ZeroFilter import ZeroFilter

def SpectrumFileReader(f,format=None):
    if (format and format.lower() == 'mzxml') or \
           f.lower().endswith('.mzxml') or \
           f.lower().endswith('.mzxml.gz'):
        return MzXMLFileReader(f)
    elif (format and format.lower() == 'mzdata') or \
             f.lower().endswith('.mzdata') or \
             f.lower().endswith('.mzdata.gz'):
        return MzDataFileReader(f)
    elif (format and format.lower() == 'mgf') or \
             f.lower().endswith('.mgf') or \
             f.lower().endswith('.mgf.gz'):
        return MGFFileReader(f)
    elif (format and format.lower() == 'mrf') or \
             f.lower().endswith('.mrf') or \
             f.lower().endswith('.mrf.gz'):
        return MRFFileReader(f)
    else:
        raise "Can't determine file format from filename or format specification"

def splitSpectrumFileExtn(f):
    if f.lower().endswith('.mzxml'):
        return (f[:-6],'mzxml','')
    elif f.lower().endswith('.mzxml.gz'):
        return (f[:-9],'mzxml','gz')
    elif f.lower().endswith('.mgf'):
        return (f[:-4],'mgf','')
    elif f.lower().endswith('.mgf.gz'):
        return (f[:-7],'mgf','gz')
    elif f.lower().endswith('.mrf'):
        return (f[:-4],'mrf','')
    elif f.lower().endswith('.mrf.gz'):
        return (f[:-7],'mrf','gz')
    elif f.lower().endswith('.mzdata'):
        return (f[:-7],'mzdata','')
    elif f.lower().endswith('.mzdata.gz'):
        return (f[:-10],'mzdata','gz')
    
